% Plot function
function figures=fplot(dt,lr,disr,chr,curr,lb,disb,chb,curb,li,disi,chi,curi,Lg)

close all

%% Load schedule
figure
hold on
box on
grid on
t=1:dt:24;
pt=plot(t,Lg,'-p');
p1=plot(t,lr(1,:),'-+');
p2=plot(t,lb(1,:),'-o');
p3=plot(t,li(1,:),'-^');

set(gca,'FontName','Arial');
set(gca,'FontSize',14);

set(pt,'Color',[0,0,0],'MarkerSize',10,'LineWidth',2);
set(p1,'Color',[0.2,0.2,0.2],'MarkerSize',10,'LineWidth',2);
set(p2,'Color',[0.4,0.4,0.4],'MarkerSize',10,'LineWidth',2);
set(p3,'Color',[0.6,0.6,0.6],'MarkerSize',10,'LineWidth',2);

title('Load schedule');

legend('Total load','Residential customer 1','Business customer 1', 'Industrial customer 1' ,1);
xlabel('(Time.)');
ylabel('Power usage.');

%% Storage unit 
% residential
figure
hold on
box on
grid on
t=1:dt:24;
p1=plot(t,curr(1,:),'-p');
% p2=plot(t,disr(1,:),'-+');
p2=plot(t,chr(1,:)-disr(1,:),'-o');
% p4=plot(t,li(1,:),'-^');

set(gca,'FontName','Arial');
set(gca,'FontSize',14);

% set(pt,'Color',[0,0,0],'MarkerSize',10,'LineWidth',2);
set(p1,'Color',[0.2,0.2,0.2],'MarkerSize',10,'LineWidth',2);
set(p2,'Color',[0.4,0.4,0.4],'MarkerSize',10,'LineWidth',2);
% set(p3,'Color',[0.6,0.6,0.6],'MarkerSize',10,'LineWidth',2);

title('Storage unit for residential user');

legend('Current storage capacity','Charging power',1);
xlabel('(Time.)');
ylabel('Power usage (kWh).');



% business
figure
hold on
box on
grid on
t=1:dt:24;
p1=plot(t,curb(1,:),'-p');
% p2=plot(t,disr(1,:),'-+');
p2=plot(t,chb(1,:)-disb(1,:),'-o');
% p4=plot(t,li(1,:),'-^');

set(gca,'FontName','Arial');
set(gca,'FontSize',14);

% set(pt,'Color',[0,0,0],'MarkerSize',10,'LineWidth',2);
set(p1,'Color',[0.2,0.2,0.2],'MarkerSize',10,'LineWidth',2);
set(p2,'Color',[0.4,0.4,0.4],'MarkerSize',10,'LineWidth',2);
% set(p3,'Color',[0.6,0.6,0.6],'MarkerSize',10,'LineWidth',2);

title('Storage unit for business user');

legend('Current storage capacity','Charging power',1);
xlabel('(Time.)');
ylabel('Power usage (kWh).');



% Industrial
figure
hold on
box on
grid on
t=1:dt:24;
p1=plot(t,curi(1,:),'-p');
% p2=plot(t,disr(1,:),'-+');
p2=plot(t,chi(1,:)-disi(1,:),'-o');
% p4=plot(t,li(1,:),'-^');

set(gca,'FontName','Arial');
set(gca,'FontSize',14);

% set(pt,'Color',[0,0,0],'MarkerSize',10,'LineWidth',2);
set(p1,'Color',[0.2,0.2,0.2],'MarkerSize',10,'LineWidth',2);
set(p2,'Color',[0.4,0.4,0.4],'MarkerSize',10,'LineWidth',2);
% set(p3,'Color',[0.6,0.6,0.6],'MarkerSize',10,'LineWidth',2);

title('Storage unit for industrial user');

legend('Current storage capacity','Charging power',1);
xlabel('(Time.)');
ylabel('Power usage (kWh).');

figures=1;