% Plot function
function figures=fplot(dt,lr,disr,chr,curr,lb,disb,chb,curb,li,disi,chi,curi,Lg)

close all

%% Load schedule
figure
hold on
box on
grid on
num=size(Lg,2);
t=1:dt:(num-1)*dt+1;

sizet=size(t,2)*2;

tre=zeros(1,sizet);

lrre=zeros(3,sizet);
disrre=zeros(3,sizet);
chrre=zeros(3,sizet);
currre=zeros(3,sizet);

lbre=zeros(2,sizet);
disbre=zeros(2,sizet);
chbre=zeros(2,sizet);
curbre=zeros(2,sizet);

lire=zeros(2,sizet);
disire=zeros(2,sizet);
chire=zeros(2,sizet);
curire=zeros(2,sizet);

for i=1:sizet;
   if mod(i,2)==1
      tre(i)=t((i+1)/2);

   else
       tre(i)=t(i/2)+dt-0.0001;

   end
end



Lgre=zeros(1,sizet);
for i=1:sizet;
   if mod(i,2)==1
      Lgre(i)=Lg((i+1)/2)
   else
       Lgre(i)=Lg(i/2);
   end
end

for i=1:3;
    for k=1:sizet;
        if mod(k,2)==1
            lrre(i,k)=lr(i,(k+1)/2);
            disrre(i,k)=disr(i,(k+1)/2);
            chrre(i,k)=chr(i,(k+1)/2);
            currre(i,k)=curr(i,(k+1)/2);
        else
            lrre(i,k)=lr(i,k/2);
             disrre(i)=disr(i,k/2);
            chrre(i,k)=chr(i,k/2);         
            currre(i,k)=curr(i,k/2);
        end 
    end
end

for i=1:2;
    for k=1:sizet;
        if mod(k,2)==1
            lbre(i,k)=lb(i,(k+1)/2);
            lire(i,k)=li(i,(k+1)/2)
            disbre(i,k)=disb(i,(k+1)/2);
            chbre(i,k)=chb(i,(k+1)/2);
            curbre(i,k)=curb(i,(k+1)/2); 
            disire(i,k)=disi(i,(k+1)/2);
            chire(i,k)=chi(i,(k+1)/2);
            curire(i,k)=curi(i,(k+1)/2);
        else
            lbre(i,k)=lb(i,(k)/2);
            lire(i,k)=li(i,(k)/2)           
            disbre(i,k)=disb(i,k/2);
            chbre(i,k)=chb(i,k/2);
            curbre(i,k)=curb(i,k/2); 
            disire(i,k)=disi(i,k/2);
            chire(i,k)=chi(i,k/2);
            curire(i,k)=curi(i,k/2);
        end 
    end
end

for i=1:2;
    for k=1:sizet;
        if mod(k,2)==1
            lbre(i,k)=lb(i,(k+1)/2)
        else
            lbre(i,k)=lb(i,k/2);
        end 
    end
end

for i=1:2;
    for k=1:sizet;
        if mod(k,2)==1
            lire(i,k)=li(i,(k+1)/2)
        else
            lire(i,k)=li(i,k/2);
        end 
    end
end

%% load scheduling
% pt=plot(t,Lg,'-p');
pt=plot(tre-1,Lgre,'-p');
pr=plot(tre-1,50.*sum(lrre,1),'-+');
pb=plot(tre-1,sum(lbre,1),'-o');
pi=plot(tre-1,sum(lire,1),'-s');

set(gca,'FontName','Arial');
set(gca,'FontSize',14);

set(pt,'Color',[0,0,0],'MarkerSize',8,'LineWidth',2);
set(pr,'Color',[0.2,0.2,0.2],'MarkerSize',8,'LineWidth',2);
set(pb,'Color',[0.3,0.3,0.3],'MarkerSize',8,'LineWidth',2);
set(pi,'Color',[0.4,0.4,0.4],'MarkerSize',8,'LineWidth',2);

% title('Load schedule');

legend('Total load','Residential','Business', 'Industrial',2);
xlabel('Time of a day.');
ylabel('Power usage (kWh).');
axis([0,24,0,700]);
% 
% %% Load for each types of customer
% % Residential
% figure
% hold on
% box on 
% grid on
% pr1=plot(tre-1,55.*lrre(1,:),'-+');
% pr2=plot(tre-1,55.*lrre(2,:),'-.+');
% pr3=plot(tre-1,55.*lrre(3,:),':+');
% 
% set(gca,'FontName','Arial');
% set(gca,'FontSize',14);
% % set(pt,'Color',[0,0,0],'MarkerSize',10,'LineWidth',2);
% set(pr1,'Color',[0.,0.,0.],'MarkerSize',10,'LineWidth',2);
% set(pr2,'Color',[0.3,0.3,0.3],'MarkerSize',10,'LineWidth',2);
% set(pr3,'Color',[0.5,0.5,0.5],'MarkerSize',10,'LineWidth',2);
% 
% legend('Residential  #1','Residential  #2', 'Residential  #3',1);
% xlabel('Time of a day.');
% ylabel('Power usage (kWh).');
% axis([0,24,0,200]);
% 
% 
% % Business
% figure
% hold on
% box on 
% grid on
% 
% pb1=plot(tre,lbre(1,:),'-o');
% pb2=plot(tre,lbre(2,:),'-.o');
% 
% set(gca,'FontName','Arial');
% set(gca,'FontSize',14);
% 
% set(pb1,'Color',[0.,0.,0.],'MarkerSize',10,'LineWidth',2);
% set(pb2,'Color',[0.4,0.4,0.4],'MarkerSize',10,'LineWidth',2);
% 
% legend('Business  #1','Business  #2',2);
% xlabel('Time of a day.');
% ylabel('Power usage (kWh).');
% axis([0,24,0,250]);
% 
% % Industrial
% figure
% hold on
% box on 
% grid on
% 
% pi1=plot(tre-1,lire(1,:),'-s');
% pi2=plot(tre-1,lire(2,:),'-.s');
% 
% set(gca,'FontName','Arial');
% set(gca,'FontSize',14);
% 
% set(pi1,'Color',[0.,0.,0.],'MarkerSize',10,'LineWidth',2);
% set(pi2,'Color',[0.4,0.4,0.4],'MarkerSize',10,'LineWidth',2);
% 
% legend('Industrial #1','Industrial #2',1);
% xlabel('Time of a day.');
% ylabel('Power usage (kWh).');
% axis([0,24,0,250]);
% 
% %% Storage unit 
% % residential
% figure
% hold on
% box on
% grid on
% 
% prt1=plot(tre-1,currre(1,:),'-+');
% prc1=plot(tre-1,chrre(1,:)-disrre(1,:),'-^');
% 
% prt2=plot(tre-1,currre(2,:),'-.+');
% prc2=plot(tre-1,chrre(2,:)-disrre(2,:),'-.^');
% 
% prt3=plot(tre-1,currre(3,:),':+');
% prc3=plot(tre-1,chrre(3,:)-disrre(3,:),':^');
% 
% set(gca,'FontName','Arial');
% set(gca,'FontSize',14);
% 
% % set(pt,'Color',[0,0,0],'MarkerSize',10,'LineWidth',2);
% set(prt1,'Color',[0.,0.,0.],'MarkerSize',10,'LineWidth',2);
% set(prc1,'Color',[0.,0.,0.],'MarkerSize',10,'LineWidth',2);
% set(prt2,'Color',[0.3,0.3,0.3],'MarkerSize',10,'LineWidth',2);
% set(prc2,'Color',[0.3,0.3,0.3],'MarkerSize',10,'LineWidth',2);
% set(prt3,'Color',[0.5,0.5,0.5],'MarkerSize',10,'LineWidth',2);
% set(prc3,'Color',[0.5,0.5,0.5],'MarkerSize',10,'LineWidth',2);
% 
% % set(p3,'Color',[0.6,0.6,0.6],'MarkerSize',10,'LineWidth',2);
% 
% % title('Storage unit for residential user');
% 
% legend('Residential #1 current storage','Residential #1 charging status','Residential #2 current storage','Residential #2 charging status','Residential #3 current storage','Residential #3 charging status',-1);
% xlabel('Time of a day.');
% ylabel('Power usage (kWh).');
% axis([0,24,-2,10]);
% 
% 
% % business
% figure
% hold on
% box on
% grid on
% 
% pbt1=plot(tre-1,curbre(1,:),'-o');
% pbc1=plot(tre-1,chbre(1,:)-disbre(1,:),'-^');
% 
% pbt2=plot(tre-1,curbre(2,:),'-.o');
% pbc2=plot(tre-1,chbre(2,:)-disbre(2,:),'-.^');
% 
% set(gca,'FontName','Arial');
% set(gca,'FontSize',14);
% 
% % set(pt,'Color',[0,0,0],'MarkerSize',10,'LineWidth',2);
% set(pbt1,'Color',[0.,0.,0.],'MarkerSize',10,'LineWidth',2);
% set(pbc1,'Color',[0.,0.,0.],'MarkerSize',10,'LineWidth',2);
% set(pbt2,'Color',[0.3,0.3,0.3],'MarkerSize',10,'LineWidth',2);
% set(pbc2,'Color',[0.3,0.3,0.3],'MarkerSize',10,'LineWidth',2);
% 
% % set(p3,'Color',[0.6,0.6,0.6],'MarkerSize',10,'LineWidth',2);
% 
% legend('Business #1 current storage','Business #1 charging status','Business #2 current storage','Business #2 charging status',2);
% xlabel('Time of a day.');
% ylabel('Power usage (kWh).');
% axis([0,24,-100,600]);
% 
% 
% % Industrial
% figure
% hold on
% box on
% grid on
% 
% pit1=plot(tre-1,curire(1,:),'-s');
% pic1=plot(tre-1,chire(1,:)-disire(1,:),'-^');
% 
% pit2=plot(tre-1,curire(2,:),'-.s');
% pic2=plot(tre-1,chire(2,:)-disire(2,:),'-.^');
% 
% set(gca,'FontName','Arial');
% set(gca,'FontSize',14);
% 
% set(pit1,'Color',[0.,0.,0.],'MarkerSize',10,'LineWidth',2);
% set(pic1,'Color',[0.,0.,0.],'MarkerSize',10,'LineWidth',2);
% set(pit2,'Color',[0.3,0.3,0.3],'MarkerSize',10,'LineWidth',2);
% set(pic2,'Color',[0.3,0.3,0.3],'MarkerSize',10,'LineWidth',2);
% 
% % title('Storage unit for industrial user');
% 
% legend('Industrial #1 current storage','Industrial #1 charging status','Industrial #2 current storage','Industrial #2 charging status',2);
% xlabel('Time of a day.');
% ylabel('Power usage (kWh).');
% axis([0,24,-100,600]);
% 
% figures=1;